'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Map2 = require('./Map');

var _Map3 = _interopRequireDefault(_Map2);

var _Match = require('./Match');

var _Match2 = _interopRequireDefault(_Match);

var _PromiseTask = require('../tasks/PromiseTask');

var _PromiseTask2 = _interopRequireDefault(_PromiseTask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Map for PromiseTask
 *
 * Maps the default ways to get a PromiseTask
 */
var PromiseMap = function (_Map) {
  _inherits(PromiseMap, _Map);

  function PromiseMap() {
    _classCallCheck(this, PromiseMap);

    return _possibleConstructorReturn(this, (PromiseMap.__proto__ || Object.getPrototypeOf(PromiseMap)).apply(this, arguments));
  }

  _createClass(PromiseMap, [{
    key: 'match',

    /**
     * Match argument with a specific PromiseMap
     *
     * @param {Promise} promise promise to wait for
     * @param {Function} complete function to be called on complete
     * @param {Function} recover function to be called on recover
     * @return {Match} match
     */
    value: function match() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (args.length === 3 && _typeof(args[0]) === 'object' && typeof args[1] === 'function' && typeof args[2] === 'function') {
        return new _Match2.default(new (Function.prototype.bind.apply(_PromiseTask2.default, [null].concat(args)))());
      } else if (args.length === 2 && _typeof(args[0]) === 'object' && typeof args[1] === 'function') {
        return new _Match2.default(new (Function.prototype.bind.apply(_PromiseTask2.default, [null].concat(args)))());
      } else if (args.length === 1 && _typeof(args[0]) === 'object') {
        return new _Match2.default(new (Function.prototype.bind.apply(_PromiseTask2.default, [null].concat(args)))());
      } else {
        return undefined;
      }
    }
  }]);

  return PromiseMap;
}(_Map3.default);

exports.default = PromiseMap;